﻿#!/usr/bin/perl
use Switch;
use DBI;
use FileHandle;
use Time::Local;

($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time - 3600);

$year += 1900;
$mon = sprintf("%02d", $mon + 1);
$mday = sprintf("%02d", $mday);
$sdate = "$year-$mon-$mday";
$startH = $hour;
if($hour eq 23){
	$endH = 24;
}else{
	$endH = $hour + 1;
}

#任意の時間を処理する場合、以下を設定
#$sdate = '2010-06-02';
#$startH = '01';
#$endH = '02';
#
# 保存先
$JPGsource = "../OnesegWWW/httpd-doc/thm/";
#
# TSの場所
$TSsource ='D:\\Record\\';
#
# EPG DB
$DBNAME = 'c:\oneseg24\epg.db';

#
	my $dsn = 'DBI:SQLite:dbname='.$DBNAME;
	my $dbh = DBI->connect($dsn, undef, undef, {RaiseError => 1, AutoCommit => 0});
	my $sql = <<END;
select
    dc_id,
    dc_name
    from
    da_channel
    order by
    dc_id
END
	my $sth = $dbh->prepare($sql);
	my $rv = $sth->execute();
	my @channel = ();
	while (my $ref = $sth->fetch()) {
		my($dc_id, $dc_name) = @$ref;
		push(@channel, $dc_id);
	}
	my $sql = <<END;
select
    strftime('%Y%m%d-%H%M%S', e.dv_start_time),
    c.dc_ch
    from
    da_event e inner join da_channel c 
    on
    e.dv_service_id = c.dc_service_id 
    where
    e.dv_start_time >= datetime(?,?) and e.dv_start_time < datetime(?,?) and c.dc_id = ?
    order by
    e.dv_start_time
END
;#

    undef $sth;
    my $sth = $dbh->prepare($sql);
    foreach my $dc_id (@channel) {
	my $rv = $sth->execute($sdate,"$startH hours", $sdate,"$endH hours", $dc_id);
	while (my $ref = $sth->fetch()) {
	$$ref[0] =~ /[0-9][0-9]([0-9][0-9][0-9][0-9][0-9][0-9]-[0-9][0-9][0-9][0-9][0-9][0-9])/;
	$special = $JPGsource . $1;
	$special .="-xxxxxx-";
	$special .= $$ref[1] . ".jpg";
	
	#すでにサムネがあったら作らない。
	if(-e $special){print "[no action]\n";$log="[COM] no action. $special is already maked.";}
	else{print "[make]";
#	print "$special\n";
	#サムネ生成ソースtsファイルを指定。
	$$ref[0] =~ /[0-9][0-9]([0-9][0-9][0-9][0-9][0-9][0-9])-([0-9][0-9])([0-9][0-9])[0-9][0-9]/;
	$source =  $TSsource . $1 . "\\" .$1 . $2 . "_Ch" . $$ref[1] . ".ts";
	$sp_min = $3;
	$time = $sp_min * 60; $time = $time + 40;
                             													
	#print $source ."\n";
                             													
	#サムネ生成
	$command ="ffmpeg -i $source -f image2 -vframes 1 -ss $time -s 107x60 -an -deinterlace $special";
 	if(-e $source){
		$log= "[Com] $command";
 		system $command;
	}
        else{print "TSfile not found. \n"; $log="TS not found. \n";}
                             													
	}
	}
                             													
}